%define name		activemq
%define version		1.5
%define release		3jpp
%define	section		free


Name:		%{name}
Summary:	ActiveMQ Messaging Fabric 
Url:		http://activemq.codehaus.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache Software License 2.0
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	http://dist.codehaus.org/activemq/distributions/activemq-release-1.5-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        activemq-1.5-jpp-depmap.xml
Patch0:		activemq-1.5-jpp.patch
Patch1:		activemq-1.5-GBeanInfoBuilder.patch
Patch2:		activemq-1.5-ZeroconfDiscoveryAgent.patch

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	junit
BuildRequires:	maven
BuildRequires:	activecluster-bootstrap
BuildRequires:	aopalliance
BuildRequires:	asm
BuildRequires:	axion
BuildRequires:	axis >= 0:1.2
BuildRequires:	berkeleydb
BuildRequires:	berkeleydb-native
BuildRequires:	carol
BuildRequires:	castor
BuildRequires:	cglib
BuildRequires:	concurrent
BuildRequires:	derby
BuildRequires:	emberio
BuildRequires:	geronimo-specs >= 0:1.0-0.M2
BuildRequires:	geronimo-modules >= 0:1.0-0.M2
BuildRequires:	howl-logger >= 0:0.1.8
BuildRequires:	hsqldb
BuildRequires:	jakarta-commons-beanutils
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-dbcp
BuildRequires:	jakarta-commons-discovery
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-pool
BuildRequires:	jakarta-commons-primitives
BuildRequires:	jasper5
BuildRequires:	javacc
BuildRequires:	jdbm
BuildRequires:	jgroups
BuildRequires:	jmdns
BuildRequires:	jmock
BuildRequires:	jotm >= 0:2.0.5
BuildRequires:	jrms
BuildRequires:	jxta
BuildRequires:	log4j
BuildRequires:	openejb
BuildRequires:	p2psockets
BuildRequires:	jetty5
BuildRequires:	spring-all
BuildRequires:	regexp
BuildRequires:	xalan-j2
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis
BuildRequires:	xmlbeans
BuildRequires:	xpp3
BuildRequires:	xstream

Requires:	activecluster-bootstrap
Requires:	aopalliance
Requires:	asm
Requires:	axion
Requires:	axis >= 0:1.2
Requires:	berkeleydb
Requires:	carol
Requires:	castor
Requires:	cglib
Requires:	concurrent
Requires:	derby
Requires:	emberio
Requires:	geronimo-specs >= 0:1.0-0.M2
Requires:	geronimo-modules >= 0:1.0-0.M2
Requires:	howl-logger >= 0:0.1.8
Requires:	hsqldb
Requires:	jakarta-commons-beanutils
Requires:	jakarta-commons-cli
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-dbcp
Requires:	jakarta-commons-discovery
Requires:	jakarta-commons-httpclient
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-pool
Requires:	jakarta-commons-primitives
Requires:	jasper5
Requires:	jdbm
Requires:	jgroups
Requires:	jmdns
Requires:	jmock
Requires:	jotm >= 0:2.0.5
Requires:	jrms
Requires:	jxta
Requires:	log4j
Requires:	openejb
Requires:	p2psockets
Requires:	jetty5
Requires:	spring-all
Requires:	regexp
Requires:	xalan-j2
Requires:	xerces-j2
Requires:	xml-commons-apis
Requires:	xmlbeans
Requires:	xpp3
Requires:	xstream

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
ActiveMQ is an open source, Apache 2.0 licensed, 
high performance Messaging Fabric consisting of a 
scalable cluster of Message Brokers and a complete 
JMS 1.1 provider which integrates seamlessly into 
J2EE containers, light weight containers and any 
Java application.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}-release-%{version}

chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
#  mv $f $f.no
  rm $f
done
# some of these tests will fail - they were removed from CVS in Dec 2004
rm  modules/core/src/test/org/codehaus/activemq/transport/reliable/*
# this test often fails
rm modules/core/src/test/org/codehaus/activemq/JmsSessionRecoverTest.java

export DEPCAT=$(pwd)/activemq-1.5-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > activemq-1.5-depmap.new.xml


%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags

#         <jar>exolabcore.jar</jar>
#         <jar>ibmaio.jar</jar>
#         <jar>jmscts.jar</jar>
mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
activecluster \
aopalliance \
axion \
axis/axis \
axis/axis-ant \
axis/jaxrpc \
axis/saaj \
axis/wsdl4j \
castor \
cglib \
asm/asm \
berkeleydb \
berkeleydb-native \
commons-beanutils \
commons-cli \
commons-collections \
commons-dbcp \
commons-discovery \
commons-httpclient \
commons-logging \
commons-pool \
commons-primitives \
concurrent \
derby/derby \
derby/derbynet \
emberio \
geronimo/core \
geronimo/kernel \
geronimo/network \
geronimo/remoting \
geronimo/security \
geronimo/spec-j2ee-1.4 \
geronimo/spec-j2ee-jacc-1.0 \
geronimo/spec-j2ee-management-1.0 \
geronimo/spec-jms-1.1 \
geronimo/spec-jta-1.0.1B \
geronimo/system \
howl-logger \
hsqldb \
jasper5-compiler \
jasper5-runtime \
javacc \
jdbm \
jgroups \
jmdns \
jmock \
jmock-cglib \
jotm/jotm \
carol/ow_carol \
jotm/jrmp-stubs \
jrms \
junit \
jxta \
log4j \
openejb/core \
p2psockets/core \
jetty5/jetty5 \
regexp \
spring \
xalan-j2 \
xerces-j2 \
xml-commons-apis \
xmlbeans/xbean \
xpp3 \
xstream \


#         <jar>maven-itest-plugin.jar</jar>
mkdir -p .maven/repository/JPP/plugins
build-jar-repository -s -p .maven/repository/JPP/plugins \
geronimo/deployment-plugin \


export OPT_JAR_LIST="ant/ant-junit junit"
export MAVEN_HOME_LOCAL=$(pwd)/.maven
export MAVEN_DOCS_SRC=$(pwd)/xdocs

maven -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	-Dmaven.docs.src=$MAVEN_DOCS_SRC \
	-Dgoal=default,javadoc:generate,xdoc:transform \
	multiproject:goal

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 itests/ejb/target/%{name}-itest-ejb-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/itest-ejb-%{version}.jar
install -m 644 modules/composite/target/%{name}-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
for m in axis container core gbean ra spring tools; do
	install -m 644 modules/${m}/target/%{name}-${m}-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}/${m}-%{version}.jar
done
install -m 644 modules/core/target/%{name}-core-test-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/core-test-%{version}.jar

for s in bdbn bdb jdbc jdbm journal; do
	install -m 644 stores/${s}/target/%{name}-store-${s}-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}/store-${s}-%{version}.jar
done

for t in ember gnet http jabber jgroups jrms jxta ssl xstream zeroconf; do
	install -m 644 transports/${t}/target/%{name}-transport-${t}-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}/transport-${t}-%{version}.jar
done

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 itests/ear/target/%{name}-itest-ear-%{version}.ear \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-itest-ear-%{version}.ear
install -m 644 modules/ra/target/%{name}-ra-%{version}.rar \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-ra-%{version}.rar
install -m 644 modules/web/target/%{name}-web-%{version}.war \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-web-%{version}.war


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
for a in $(find . -name apidocs); do 
	d=$(echo ${a} | sed -e 's|/target/docs/apidocs|/|')
	mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${d}
	cp -pr ${a}/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${d}
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*
%{_datadir}/%{name}

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Mon Oct 10 2005 Ralph Apel <r.apel at r-apel.de> 0:1.5-3jpp
- Avoid '+' in project.xml

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> 0:1.5-2jpp
- Fix for location of maven.docs.src

* Mon Mar 07 2005 Ralph Apel <r.apel at r-apel.de> 0:1.5-1jpp
- First release

